<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (140)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="resumable-file-upload">Resumable file upload</h1>
    <p>With <code>fetch</code> method it’s fairly easy to upload a file.</p>
    <p>
      How to resume the upload after lost connection? There’s no built-in option
      for that, but we have the pieces to implement it.
    </p>
    <p>
      Resumable uploads should come with upload progress indication, as we
      expect big files (if we may need to resume). So, as
      <code>fetch</code> doesn’t allow to track upload progress, we’ll use
      <a href="info:xmlhttprequest">XMLHttpRequest</a>.
    </p>
    <h2 id="not-so-useful-progress-event">Not-so-useful progress event</h2>
    <p>
      To resume upload, we need to know how much was uploaded till the
      connection was lost.
    </p>
    <p>There’s <code>xhr.upload.onprogress</code> to track upload progress.</p>
    <p>
      Unfortunately, it won’t help us to resume the upload here, as it triggers
      when the data is <em>sent</em>, but was it received by the server? The
      browser doesn’t know.
    </p>
    <p>
      Maybe it was buffered by a local network proxy, or maybe the remote server
      process just died and couldn’t process them, or it was just lost in the
      middle and didn’t reach the receiver.
    </p>
    <p>That’s why this event is only useful to show a nice progress bar.</p>
    <p>
      To resume upload, we need to know <em>exactly</em> the number of bytes
      received by the server. And only the server can tell that, so we’ll make
      an additional request.
    </p>
    <h2 id="algorithm">Algorithm</h2>
    <ol type="1">
      <li>
        <p>
          First, create a file id, to uniquely identify the file we’re going to
          upload:
        </p>
        <div class="sourceCode" id="cb1">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> fileId <span class="op">=</span> <span class="va">file</span>.<span class="at">name</span> <span class="op">+</span> <span class="st">&quot;-&quot;</span> <span class="op">+</span> <span class="va">file</span>.<span class="at">size</span> <span class="op">+</span> <span class="st">&quot;-&quot;</span> <span class="op">+</span> <span class="va">file</span>.<span class="at">lastModified</span><span class="op">;</span></a></code></pre>
        </div>
        <p>
          That’s needed for resume upload, to tell the server what we’re
          resuming.
        </p>
        <p>
          If the name or the size or the last modification date changes, then
          there’ll be another <code>fileId</code>.
        </p>
      </li>
      <li>
        <p>
          Send a request to the server, asking how many bytes it already has,
          like this:
        </p>
        <div class="sourceCode" id="cb2">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">let</span> response <span class="op">=</span> <span class="cf">await</span> <span class="at">fetch</span>(<span class="st">&quot;status&quot;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">  <span class="dt">headers</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-3" title="3">    <span class="st">&quot;X-File-Id&quot;</span><span class="op">:</span> fileId<span class="op">,</span></a>
<a class="sourceLine" id="cb2-4" title="4">  <span class="op">},</span></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-6" title="6"></a>
<a class="sourceLine" id="cb2-7" title="7"><span class="co">// The server has that many bytes</span></a>
<a class="sourceLine" id="cb2-8" title="8"><span class="kw">let</span> startByte <span class="op">=</span> <span class="op">+</span>(<span class="cf">await</span> <span class="va">response</span>.<span class="at">text</span>())<span class="op">;</span></a></code></pre>
        </div>
        <p>
          This assumes that the server tracks file uploads by
          <code>X-File-Id</code> header. Should be implemented at server-side.
        </p>
        <p>
          If the file doesn’t yet exist at the server, then the server response
          should be <code>0</code>
        </p>
      </li>
      <li>
        <p>
          Then, we can use <code>Blob</code> method <code>slice</code> to send
          the file from <code>startByte</code>:
        </p>
        <div class="sourceCode" id="cb3">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="va">xhr</span>.<span class="at">open</span>(<span class="st">&quot;POST&quot;</span><span class="op">,</span> <span class="st">&quot;upload&quot;</span><span class="op">,</span> <span class="kw">true</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2"></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="co">// File id, so that the server knows which file we upload</span></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="va">xhr</span>.<span class="at">setRequestHeader</span>(<span class="st">&quot;X-File-Id&quot;</span><span class="op">,</span> fileId)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-5" title="5"></a>
<a class="sourceLine" id="cb3-6" title="6"><span class="co">// The byte we&#39;re resuming from, so the server knows we&#39;re resuming</span></a>
<a class="sourceLine" id="cb3-7" title="7"><span class="va">xhr</span>.<span class="at">setRequestHeader</span>(<span class="st">&quot;X-Start-Byte&quot;</span><span class="op">,</span> startByte)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-8" title="8"></a>
<a class="sourceLine" id="cb3-9" title="9"><span class="va">xhr</span>.<span class="va">upload</span>.<span class="at">onprogress</span> <span class="op">=</span> (e) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb3-10" title="10">  <span class="va">console</span>.<span class="at">log</span>(<span class="vs">`Uploaded </span><span class="sc">${</span>startByte <span class="op">+</span> <span class="va">e</span>.<span class="at">loaded</span><span class="sc">}</span><span class="vs"> of </span><span class="sc">${</span>startByte <span class="op">+</span> <span class="va">e</span>.<span class="at">total</span><span class="sc">}</span><span class="vs">`</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-11" title="11"><span class="op">};</span></a>
<a class="sourceLine" id="cb3-12" title="12"></a>
<a class="sourceLine" id="cb3-13" title="13"><span class="co">// file can be from input.files[0] or another source</span></a>
<a class="sourceLine" id="cb3-14" title="14"><span class="va">xhr</span>.<span class="at">send</span>(<span class="va">file</span>.<span class="at">slice</span>(startByte))<span class="op">;</span></a></code></pre>
        </div>
        <p>
          Here we send the server both file id as <code>X-File-Id</code>, so it
          knows which file we’re uploading, and the starting byte as
          <code>X-Start-Byte</code>, so it knows we’re not uploading it
          initially, but resuming.
        </p>
        <p>
          The server should check its records, and if there was an upload of
          that file, and the current uploaded size is exactly
          <code>X-Start-Byte</code>, then append the data to it.
        </p>
      </li>
    </ol>
    <p>Here’s the demo with both client and server code, written on Node.js.</p>
    <p>
      It works only partially on this site, as Node.js is behind another server
      named Nginx, that buffers uploads, passing them to Node.js when fully
      complete.
    </p>
    <p>But you can download it and run locally for the full demonstration:</p>
    <p>[codetabs src=“upload-resume” height=200]</p>
    <p>
      As we can see, modern networking methods are close to file managers in
      their capabilities – control over headers, progress indicator, sending
      file parts, etc.
    </p>
    <p>We can implement resumable upload and much more.</p>
  </body>
</html>
